declare namespace ASModule {
  type i8 = number;
  type i16 = number;
  type i32 = number;
  type u8 = number;
  type u16 = number;
  type u32 = number;
  type f32 = number;
  type f64 = number;
  type bool = any;
  const MAX_BLENGTH: i32;
  const HEADER_SIZE: u32;
  function allocateUnsafe(byteLength: i32): ~lib/arraybuffer/ArrayBuffer;
  function reallocateUnsafe(buffer: ~lib/arraybuffer/ArrayBuffer, newByteLength: i32): ~lib/arraybuffer/ArrayBuffer;
  function allocateUnsafe(length: i32): ~lib/string/String;
  function copyUnsafe(dest: ~lib/string/String, destOffset: u32, src: ~lib/string/String, srcOffset: u32, len: u32): void;
  const MAX_DOUBLE_LENGTH: i32;
  const NaN: f64;
  const Infinity: f64;
  function abort(message: ~lib/string/String, fileName: ~lib/string/String, lineNumber: u32, columnNumber: u32): void;
  var HEAP_BASE: u32;
  namespace memory {
    function compare(vl: u32, vr: u32, n: u32): i32;
    function allocate(size: u32): u32;
    function free(ptr: u32): void;
    function reset(): void;
  }
  function memcmp(vl: u32, vr: u32, n: u32): i32;
  function memmove(dest: u32, src: u32, n: u32): void;
  function memset(dest: u32, c: u8, n: u32): void;
  const HEADER_SIZE: u32;
  const MAX_LENGTH: i32;
  function compareUnsafe(str1: ~lib/string/String, offset1: u32, str2: ~lib/string/String, offset2: u32, len: u32): i32;
  enum CharCode {
    PLUS = 43,
    MINUS = 45,
    DOT = 46,
    _0 = 48,
    _1 = 49,
    _2 = 50,
    _3 = 51,
    _4 = 52,
    _5 = 53,
    _6 = 54,
    _7 = 55,
    _8 = 56,
    _9 = 57,
    A = 65,
    B = 66,
    E = 69,
    N = 78,
    O = 79,
    X = 88,
    Z = 90,
    a = 97,
    b = 98,
    e = 101,
    n = 110,
    o = 111,
    x = 120,
    z = 122,
  }
  function main(): void;
  function setUpProcess(): void;
  function _process(): process/index/Process;
  function createProcess(command: ~lib/string/String, currentDir: ~lib/string/String): void;
  class Process {
    class InputStream {
      class OutputStream {
        var process: process/index/Process;
        constructor();
        constructor();
      }
      constructor();
      constructor();
    }
    constructor(cmdline: ~lib/string/String, currentDir: ~lib/string/String);
    constructor(cmdline: ~lib/string/String, currentDir: ~lib/string/String);
    chdir(dir: ~lib/string/String): void;
    cwd: ~lib/string/String;
    uid: i32;
  }
  function computeSize(byteLength: i32): u32;
  const AL_MASK: u32;
  const MAX_SIZE_32: u32;
  function memcpy(dest: u32, src: u32, n: u32): void;
  var startOffset: u32;
  var offset: u32;
  function __memory_allocate(size: u32): u32;
  function __memory_free(ptr: u32): void;
  function __memory_reset(): void;
  const AL_BITS: u32;
  const AL_SIZE: u32;
  enum ExitStatus {
    EXIT_FAILURE = -1,
    EXIT_SUCCESS = 0,
  }
  function _main(argv: ~lib/array/Array<~lib/string/String>): i32;
  function log<~lib/string/String>(item: ~lib/string/String): void;
  namespace host {
    function _log_str(x: ~lib/string/String): void;
  }
}
export default ASModule;
